CHO_HANGUL = [
    "ㄱ",
    "ㄲ",
    "ㄴ",
    "ㄷ",
    "ㄸ",
    "ㄹ",
    "ㅁ",
    "ㅂ",
    "ㅃ",
    "ㅅ",
    "ㅆ",
    "ㅇ",
    "ㅈ",
    "ㅉ",
    "ㅊ",
    "ㅋ",
    "ㅌ",
    "ㅍ",
    "ㅎ",
]

JUNG_HANGUL = [
    "ㅏ",
    "ㅐ",
    "ㅑ",
    "ㅒ",
    "ㅓ",
    "ㅔ",
    "ㅕ",
    "ㅖ",
    "ㅗ",
    "ㅘ",
    "ㅙ",
    "ㅚ",
    "ㅛ",
    "ㅜ",
    "ㅝ",
    "ㅞ",
    "ㅟ",
    "ㅠ",
    "ㅡ",
    "ㅢ",
    "ㅣ",
]

JONG_HANGUL = [
    "",
    "ㄱ",
    "ㄲ",
    "ㄳ",
    "ㄴ",
    "ㄵ",
    "ㄶ",
    "ㄷ",
    "ㄹ",
    "ㄺ",
    "ㄻ",
    "ㄼ",
    "ㄽ",
    "ㄾ",
    "ㄿ",
    "ㅀ",
    "ㅁ",
    "ㅂ",
    "ㅄ",
    "ㅅ",
    "ㅆ",
    "ㅇ",
    "ㅈ",
    "ㅊ",
    "ㅋ",
    "ㅌ",
    "ㅍ",
    "ㅎ",
]

JUNG_COMPLETE_HANGUL = {
    "ㅘ": "ㅗㅏ",
    "ㅙ": "ㅗㅐ",
    "ㅚ": "ㅗㅣ",
    "ㅝ": "ㅜㅓ",
    "ㅞ": "ㅜㅔ",
    "ㅟ": "ㅜㅣ",
    "ㅢ": "ㅡㅣ",
}

JONG_COMPLETE_HANGUL = {
    "ㄳ": "ㄱㅅ",
    "ㄵ": "ㄴㅈ",
    "ㄶ": "ㄴㅎ",
    "ㄺ": "ㄹㄱ",
    "ㄻ": "ㄹㅁ",
    "ㄼ": "ㄹㅂ",
    "ㄽ": "ㄹㅅ",
    "ㄾ": "ㄹㅌ",
    "ㄿ": "ㄹㅍ",
    "ㅀ": "ㄹㅎ",
    "ㅄ": "ㅂㅅ",
}

JUNG_START_CHARCODE = ord(JUNG_HANGUL[0])
JUNG_END_CHARCODE = ord(JUNG_HANGUL[-1])

JONG_START_CHARCODE = ord(JONG_HANGUL[1])
JONG_END_CHARCODE = ord(JONG_HANGUL[-1])

HANGUL_START_CHARCODE = ord("가")
HANGUL_END_CHARCODE = ord("힣")

CHO_PERIOD = ord("까") - ord("가")
JONG_PERIOD = ord("개") - ord("가")

KEY_MAPS = {
    "ㅂ": "q",
    "ㅃ": "Q",
    "ㅈ": "w",
    "ㅉ": "W",
    "ㄷ": "e",
    "ㄸ": "E",
    "ㄱ": "r",
    "ㄲ": "R",
    "ㅅ": "t",
    "ㅆ": "T",
    "ㅛ": "y",
    "ㅕ": "u",
    "ㅑ": "i",
    "ㅐ": "o",
    "ㅒ": "O",
    "ㅔ": "p",
    "ㅖ": "P",
    "ㅁ": "a",
    "ㄴ": "s",
    "ㅇ": "d",
    "ㄹ": "f",
    "ㅎ": "g",
    "ㅗ": "h",
    "ㅓ": "j",
    "ㅏ": "k",
    "ㅣ": "l",
    "ㅋ": "z",
    "ㅌ": "x",
    "ㅊ": "c",
    "ㅍ": "v",
    "ㅠ": "b",
    "ㅜ": "n",
    "ㅡ": "m",
}

NUMBER_UNITS = ["", "일", "이", "삼", "사", "오", "육", "칠", "팔", "구"]

TEN_UNITS = ["", "십", "백", "천"]

THOUSAND_UNITS = [
    "",
    "만",
    "억",
    "조",
    "경",
    "해",
    "자",
    "양",
    "구",
    "간",
    "정",
    "재",
    "극",
    "항하사",
    "아승기",
    "나유타",
    "불가사의",
    "무량대수",
]

OVER_DIGIT = len(THOUSAND_UNITS) * len(TEN_UNITS)

WEEK_DAY = ["월", "화", "수", "목", "금", "토", "일"]

JOSA_LIST = {
    "이": "이/가",
    "가": "이/가",
    "을": "을/를",
    "를": "을/를",
    "은": "은/는",
    "는": "은/는",
    "으로": "으로/로",
    "로": "으로/로",
    "와": "와/과",
    "과": "와/과",
    "이나": "이나/나",
    "나": "이나/나",
    "이에": "이에/에",
    "에": "이에/에",
    "이란": "이란/란",
    "란": "이란/란",
}

NORMALIZE_CHO = [
    "g",
    "gg",
    "n",
    "d",
    "dd",
    "r",
    "m",
    "b",
    "bb",
    "s",
    "ss",
    "",
    "j",
    "jj",
    "c",
    "k",
    "t",
    "p",
    "h",
]

NORMALIZE_JUNG = [
    "a",
    "ae",
    "ya",
    "yae",
    "eo",
    "e",
    "yeo",
    "ye",
    "o",
    "wa",
    "wae",
    "oe",
    "yo",
    "u",
    "weo",
    "we",
    "wi",
    "yu",
    "eu",
    "eui",
    "i",
]

NORMALIZE_JONG = [
    "",
    "g",
    "gg",
    "gs",
    "n",
    "nj",
    "nh",
    "d",
    "r",
    "rk",
    "rm",
    "rb",
    "rs",
    "rt",
    "rp",
    "rh",
    "m",
    "b",
    "bs",
    "s",
    "ss",
    "ng",
    "j",
    "c",
    "k",
    "t",
    "p",
    "h",
]
